import _dsmapiv0
handle = _dsmapiv0.DsmApiInitialize()
#_dsmapiv0.DsmApiOpen(handle, "serial:/dev/ttyUSB0", 0)
_dsmapiv0.DsmApiOpen(handle, "tcp:localhost:8442", 0)

_dsmapiv0.DsmApiGetBusState(handle)
_dsmapiv0.DsmApiGetBusMembers(handle, 63)

dsid = [0,1,2,3,4,5,6,7,8,9,10,11]

dsid = list()
for i in bytearray(b'5\x04\x17_\xe0\x00\x00\x10\x00\x00\x00\x88'):
	dsid.append(i)

_dsmapiv0.GetRoomCount_sync(handle, dsid)

(result, GlobalZoneId, LocalZoneId, NumberOfGroups, Name) = _dsmapiv0.ZoneInfo_by_index_sync(handle, dsid, 0)
(result, DeviceCount) = _dsmapiv0.ZoneDeviceCount_only_active_sync(handle, dsid, GlobalZoneId)

_dsmapiv0.dSMInfo_sync(handle, dsid)
name = "Test"
_dsmapiv0.dSMProperties_set_name_sync(handle, dsid, name)
_dsmapiv0.dSMInfo_sync(handle, dsid)

hw_version = 0x12345678
_dsmapiv0.dSMConfig_set_dSM_config_sync(handle, dsid, dsid, hw_version)

_dsmapiv0.dSMReboot_sync(handle, dsid)

_dsmapiv0.dSMFactoryReset_sync(handle, dsid, 0xcafe)

from math import floor
from struct import *

config_data = ""
config_data += pack("<H", 4) #/*.version =*/ 
config_data += pack("<H", 0xA000) #/*.dSMC_DAC1a =*/ 
config_data += pack("<H", 0x8000) # .dSMC_DAC2a =
config_data += pack("<H", 0x9500) # .dSMC_OFFSET =
config_data += pack("<H", (16 << 8)) # .dSMC_clock =
config_data += pack("<H", 0x4100) # .mains_offset =

config_data += pack("<B", 0x66) # .dSMC_BITD =
config_data += pack("<B", 0x00) # .dSMC_BLANK1 =
config_data += pack("<B", 0x00) # .dSMC_BLANK2 =
config_data += pack("<B", 0x00) # .dSMC_BCRS =
config_data += pack("<B", 0xF4) # .dSMC_PRGR =
config_data += pack("<B", 0x00) # .dSMC_TESTMUX =

config_data += pack("<H", int(floor((1.440e-3 + -291e-6) * 68 / 560e-6 + .5))) # .upstream_start_gaps[0] =
config_data += pack("<H", int(floor((1.440e-3 + -200e-6) * 68 / 560e-6 + .5))) # .upstream_start_gaps[1] =
config_data += pack("<H", int(floor((6.304e-3 - 1.440e-3)*68/560e-6 - (68*5+68*2/3+18+4+4)/4*4 + .5))) # .upstream_between_gap =
config_data += pack("<B", 0x2) # .upstream_carrier_threshold =

config_data += pack("<B", 0) #downstream_mode_2bit, # .downstream_mode =
config_data += pack("<B", 1) # .downstream_single_bit_shape =
config_data += pack("<B", 0) # .reserved1 =

config_data += pack("<I", 179597) # .power_calibration_high =
config_data += pack("<I", 1605) # .power_calibration_low =
config_data += pack("<H", (2103 << 3)) # .power_voltage_offset =
config_data += pack("<H", (0 << 3)) # .power_current_offset_high =
config_data += pack("<H", (2334 << 3)) # .power_current_offset_low =
config_data += pack("<H", (621 << 3)) # .temperature_offset =
config_data += pack("<H", 0) # .downstream_debug =
config_data += pack("<H", int(floor(1.0 / 3.5 * (1 << 12) + 0.5))) # .trigger_MODI = 
length = len(config_data)
config_data += pack("<B", 0) * (96 - length)
config = list()
for i in config_data:
	config.append(ord(i))

_dsmapiv0.dSMConfig_set_DSP_config_sync(handle, dsid, length, config)
_dsmapiv0.dSMReboot_sync(handle, dsid)

(result, length, data) = _dsmapi.dSMConfig_get_DSP_config_sync(handle, dsid)
config_str = ""
for i in data[0:length]:
	config_str += chr(i)

dsp_config_struct = "<HHHHHHBBBBBBHHHBBBBIIHHHHHH"
unpack(dsp_config_struct, config_str)

_dsmapiv0.CircuitEnergyMeterValue_calibration_sync(handle, dsid)
_dsmapiv0.CircuitEnergyMeterValue_get_sync(handle, dsid)

_dsmapiv0.dSMStatistics_get_dS485_sync(handle, dsid)

_dsmapiv0.DsmApiClose(handle)
_dsmapiv0.DsmApiCleanup(handle)
